searchNodes=[{"doc":"","ref":"Licensir.html","title":"Licensir","type":"module"},{"doc":"RFC 4180 compliant CSV parsing and encoding for Elixir. Allows to specify other separators, so it could also be named: TSV, but it isn't.","ref":"Licensir.CSV.html","title":"Licensir.CSV","type":"module"},{"doc":"Encode a table stream into a stream of RFC 4180 compliant CSV lines for writing to a file or other IO. Options These are the options: :separator – The separator token to use, defaults to ?, . Must be a codepoint (syntax: ? + (your separator)). :delimiter – The delimiter token to use, defaults to \\r\\n . Must be a string. Examples Convert a stream of rows with cells into a stream of lines: iex&gt; [ ~w(a b) , ~w(c d) ] iex&gt; |&gt; CSV . encode iex&gt; |&gt; Enum . take ( 2 ) [ &quot;a,b \\r \\n &quot; , &quot;c,d \\r \\n &quot; ] Convert a stream of rows with cells with escape sequences into a stream of lines: iex&gt; [ [ &quot;a \\n b&quot; , &quot; \\t c&quot; ] , [ &quot;de&quot; , &quot; \\t f \\&quot; &quot; ] ] iex&gt; |&gt; CSV . encode ( separator : ?\\t , delimiter : &quot; \\n &quot; ) iex&gt; |&gt; Enum . take ( 2 ) [ &quot; \\&quot; a \\\\ nb \\&quot; \\t \\&quot; \\\\ tc \\&quot; \\n &quot; , &quot;de \\t \\&quot; \\\\ tf \\&quot; \\&quot; \\&quot; \\n &quot; ]","ref":"Licensir.CSV.html#encode/2","title":"Licensir.CSV.encode/2","type":"function"},{"doc":"","ref":"Licensir.FileAnalyzer.html","title":"Licensir.FileAnalyzer","type":"module"},{"doc":"","ref":"Licensir.FileAnalyzer.html#analyze/1","title":"Licensir.FileAnalyzer.analyze/1","type":"function"},{"doc":"A module that determines a dependency's license based on different sources gathered.","ref":"Licensir.Guesser.html","title":"Licensir.Guesser","type":"module"},{"doc":"Guess the license based on the available license data.","ref":"Licensir.Guesser.html#guess/1","title":"Licensir.Guesser.guess/1","type":"function"},{"doc":"Stores license information for a dependency.","ref":"Licensir.License.html","title":"Licensir.License","type":"module"},{"doc":"The struct that keeps information about a dependency's license. It contains: app - the depedency's name as an atom version - the version of the dependency being used license - the best guess of the license certainty - the certainty that the guessed license is correct on a scale of 0.0 to 1.0 license_mix - the license defined in the dependency's mix.exs file license_file - the license defined in the dependency's LICENSE or LICENSE.md file","ref":"Licensir.License.html#__struct__/0","title":"Licensir.License.__struct__/0","type":"function"},{"doc":"","ref":"Licensir.License.html#t:t/0","title":"Licensir.License.t/0","type":"type"},{"doc":"Consolidate different naming variants of the same license to a single name.","ref":"Licensir.NamingVariants.html","title":"Licensir.NamingVariants","type":"module"},{"doc":"Turns all variants of the names into a single one. Duplicates are removed if found in the list of variants.","ref":"Licensir.NamingVariants.html#normalize/1","title":"Licensir.NamingVariants.normalize/1","type":"function"},{"doc":"Scans the project's dependencies for their license information.","ref":"Licensir.Scanner.html","title":"Licensir.Scanner","type":"module"},{"doc":"Scans all dependencies, formats into a list, and print out the result.","ref":"Licensir.Scanner.html#scan/1","title":"Licensir.Scanner.scan/1","type":"function"},{"doc":"TableRex generates configurable, text-based tables for display","ref":"Licensir.TableRex.html","title":"Licensir.TableRex","type":"module"},{"doc":"A shortcut function to render with a one-liner. Sacrifices all customisation for those that just want sane defaults. Returns {:ok, rendered_string} on success and {:error, reason} on failure.","ref":"Licensir.TableRex.html#quick_render/3","title":"Licensir.TableRex.quick_render/3","type":"function"},{"doc":"A shortcut function to render with a one-liner. Sacrifices all customisation for those that just want sane defaults. Returns the rendered_string on success and raises RuntimeError on failure.","ref":"Licensir.TableRex.html#quick_render!/3","title":"Licensir.TableRex.quick_render!/3","type":"function"},{"doc":"Defines a struct that represents a single table cell, and helper functions. A cell stores both the original data and the string-rendered version, this decision was taken as a tradeoff: this way uses more memory to store the table structure but the renderers gain the ability to get direct access to the string-coerced data rather than having to risk repeated coercion or handle their own storage of the computer values. Fields: raw_value : The un-coerced original value rendered_value : The stringified value for rendering wrapped_lines : A list of 1 or more string values representing the line(s) within the cell to be rendered align : :left : left align text in the cell. :center : center text in the cell. :right : right align text in the cell. nil : align text in cell according to column alignment. color : the ANSI color of the cell. If creating a Cell manually: raw_value is the only required key to enable that Cell to work well with the rest of TableRex. It should be set to a piece of data that can be rendered to string.","ref":"Licensir.TableRex.Cell.html","title":"Licensir.TableRex.Cell","type":"module"},{"doc":"","ref":"Licensir.TableRex.Cell.html#height/1","title":"Licensir.TableRex.Cell.height/1","type":"function"},{"doc":"Converts the passed value to be a normalised %Cell{} struct. If a non %Cell{} value is passed, this function returns a new %Cell{} struct with: the rendered_value key set to the stringified binary of the value passed in. the raw_value key set to original data passed in. any other options passed are applied over the normal struct defaults, which allows overriding alignment &amp; color. If a %Cell{} is passed in with no rendered_value key, then the raw_value key's value is rendered and saved against it, otherwise the Cell is passed through untouched. This is so that advanced use cases which require direct Cell creation and manipulation are not hindered.","ref":"Licensir.TableRex.Cell.html#to_cell/1","title":"Licensir.TableRex.Cell.to_cell/1","type":"function"},{"doc":"","ref":"Licensir.TableRex.Cell.html#to_cell/2","title":"Licensir.TableRex.Cell.to_cell/2","type":"function"},{"doc":"","ref":"Licensir.TableRex.Cell.html#t:t/0","title":"Licensir.TableRex.Cell.t/0","type":"type"},{"doc":"Defines a struct that represents a column's metadata The align field can be one of :left, :center or :right.","ref":"Licensir.TableRex.Column.html","title":"Licensir.TableRex.Column","type":"module"},{"doc":"","ref":"Licensir.TableRex.Column.html#t:t/0","title":"Licensir.TableRex.Column.t/0","type":"type"},{"doc":"An Elixir behaviour that defines the API Renderers should conform to, allowing for display output in a variety of formats.","ref":"Licensir.TableRex.Renderer.html","title":"Licensir.TableRex.Renderer","type":"behaviour"},{"doc":"Returns a Map of the options and their default values required by the renderer.","ref":"Licensir.TableRex.Renderer.html#c:default_options/0","title":"Licensir.TableRex.Renderer.default_options/0","type":"callback"},{"doc":"Renders a passed %TableRex.Table{} struct into a string.","ref":"Licensir.TableRex.Renderer.html#c:render/2","title":"Licensir.TableRex.Renderer.render/2","type":"callback"},{"doc":"Return value of the render function.","ref":"Licensir.TableRex.Renderer.html#t:render_return/0","title":"Licensir.TableRex.Renderer.render_return/0","type":"type"},{"doc":"Renderer module which handles outputting ASCII-style tables for display.","ref":"Licensir.TableRex.Renderer.Text.html","title":"Licensir.TableRex.Renderer.Text","type":"module"},{"doc":"Provides a level of sane defaults for the Text rendering module.","ref":"Licensir.TableRex.Renderer.Text.html#default_options/0","title":"Licensir.TableRex.Renderer.Text.default_options/0","type":"function"},{"doc":"Implementation of the TableRex.Renderer behaviour. Available styling options. horizontal_styles controls horizontal separators and can be one of: :all : display separators between and around every row. :header : display outer and header horizontal separators only. :frame : display outer horizontal separators only. :off : display no horizontal separators. vertical_styles controls vertical separators and can be one of: :all : display between and around every column. :frame : display outer vertical separators only. :off : display no vertical separators.","ref":"Licensir.TableRex.Renderer.Text.html#render/2","title":"Licensir.TableRex.Renderer.Text.render/2","type":"function"},{"doc":"The data structure for the TableRex.Renderer.Text rendering module, it holds results of style &amp; dimension calculations to be passed down the render pipeline.","ref":"Licensir.TableRex.Renderer.Text.Meta.html","title":"Licensir.TableRex.Renderer.Text.Meta","type":"module"},{"doc":"Retrieves the column width at the given column index.","ref":"Licensir.TableRex.Renderer.Text.Meta.html#col_width/2","title":"Licensir.TableRex.Renderer.Text.Meta.col_width/2","type":"function"},{"doc":"Retrieves the &quot;inner width&quot; of the table, which is the full width minus any frame.","ref":"Licensir.TableRex.Renderer.Text.Meta.html#inner_width/1","title":"Licensir.TableRex.Renderer.Text.Meta.inner_width/1","type":"function"},{"doc":"Retrieves the row width at the given row index.","ref":"Licensir.TableRex.Renderer.Text.Meta.html#row_height/2","title":"Licensir.TableRex.Renderer.Text.Meta.row_height/2","type":"function"},{"doc":"A set of functions for working with tables. The Table is represented internally as a struct though the fields are private and must not be accessed directly. Instead, use the functions in this module.","ref":"Licensir.TableRex.Table.html","title":"Licensir.TableRex.Table","type":"module"},{"doc":"Adds a single row to the table.","ref":"Licensir.TableRex.Table.html#add_row/2","title":"Licensir.TableRex.Table.add_row/2","type":"function"},{"doc":"Adds multiple rows to the table.","ref":"Licensir.TableRex.Table.html#add_rows/2","title":"Licensir.TableRex.Table.add_rows/2","type":"function"},{"doc":"Removes column meta for all columns, effectively resetting column meta back to the default options across the board.","ref":"Licensir.TableRex.Table.html#clear_all_column_meta/1","title":"Licensir.TableRex.Table.clear_all_column_meta/1","type":"function"},{"doc":"Removes all row data from the table, keeping everything else.","ref":"Licensir.TableRex.Table.html#clear_rows/1","title":"Licensir.TableRex.Table.clear_rows/1","type":"function"},{"doc":"Retrieves the value of a column meta option at the specified col_index. If no value has been set, default values are returned.","ref":"Licensir.TableRex.Table.html#get_column_meta/3","title":"Licensir.TableRex.Table.get_column_meta/3","type":"function"},{"doc":"Returns a boolean detailing if the passed table has a header row set.","ref":"Licensir.TableRex.Table.html#has_header?/1","title":"Licensir.TableRex.Table.has_header?/1","type":"function"},{"doc":"Returns a boolean detailing if the passed table has any row data set.","ref":"Licensir.TableRex.Table.html#has_rows?/1","title":"Licensir.TableRex.Table.has_rows?/1","type":"function"},{"doc":"Creates a new blank table. The table created will not be able to be rendered until it has some row data. Examples iex&gt; Table . new % Licensir.TableRex.Table { }","ref":"Licensir.TableRex.Table.html#new/0","title":"Licensir.TableRex.Table.new/0","type":"function"},{"doc":"Creates a new table with an initial set of rows and an optional header and title.","ref":"Licensir.TableRex.Table.html#new/3","title":"Licensir.TableRex.Table.new/3","type":"function"},{"doc":"Sets cell level information such as alignment.","ref":"Licensir.TableRex.Table.html#put_cell_meta/4","title":"Licensir.TableRex.Table.put_cell_meta/4","type":"function"},{"doc":"Sets column level information such as padding and alignment.","ref":"Licensir.TableRex.Table.html#put_column_meta/3","title":"Licensir.TableRex.Table.put_column_meta/3","type":"function"},{"doc":"Sets a list as the optional header row. Set to nil or [] to remove an already set header from renders.","ref":"Licensir.TableRex.Table.html#put_header/2","title":"Licensir.TableRex.Table.put_header/2","type":"function"},{"doc":"Sets cell level information for the header cells.","ref":"Licensir.TableRex.Table.html#put_header_meta/3","title":"Licensir.TableRex.Table.put_header_meta/3","type":"function"},{"doc":"Sets a string as the optional table title. Set to nil or &quot;&quot; to remove an already set title from renders.","ref":"Licensir.TableRex.Table.html#put_title/2","title":"Licensir.TableRex.Table.put_title/2","type":"function"},{"doc":"Renders the current table state to string, ready for display via IO.puts/2 or other means. At least one row must have been added before rendering. Returns {:ok, rendered_string} on success and {:error, reason} on failure.","ref":"Licensir.TableRex.Table.html#render/2","title":"Licensir.TableRex.Table.render/2","type":"function"},{"doc":"Renders the current table state to string, ready for display via IO.puts/2 or other means. At least one row must have been added before rendering. Returns the rendered string on success, or raises TableRex.Error on failure.","ref":"Licensir.TableRex.Table.html#render!/2","title":"Licensir.TableRex.Table.render!/2","type":"function"},{"doc":"Sorts the table rows by using the values in a specified column. This is very much a simple sorting function and relies on Elixir's built-in comparison operators &amp; types to cover the basic cases. As each cell retains the original value it was created with, we use that value to sort on as this allows us to sort on many built-in types in the most obvious fashions. Remember that rows are stored internally in reverse order that they will be output in, to allow for fast insertion. Parameters: ` column_index ` : the 0 - indexed column number to sort by ` order ` : supply :desc or :asc for sort direction . Returns a new Table, with sorted rows.","ref":"Licensir.TableRex.Table.html#sort/3","title":"Licensir.TableRex.Table.sort/3","type":"function"},{"doc":"","ref":"Licensir.TableRex.Table.html#t:t/0","title":"Licensir.TableRex.Table.t/0","type":"type"},{"doc":"MIT License Copyright (c) 2017 Unnawut Leepaisalsuwanna Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"License","type":"extras"},{"doc":"Licensir An Elixir mix task that list the license(s) of all installed packages in your project.","ref":"readme.html","title":"Overview","type":"extras"},{"doc":"The package can be installed by adding :licensir to your list of dependencies in mix.exs : def deps do [ { :licensir , &quot;~&gt; 0.7&quot; , only : :dev , runtime : false } ] end This mix task in most cases only needs to be run on a development machine and independent from the runtime applications, hence the only: dev, runtime: false options. Install locally If you do not wish to include this tool as part of your dependencies, you may also install it locally by running: $ mix archive . install hex licensir 0.7 . 0 Now you can access this tool from any path on your local machine that has access to mix .","ref":"readme.html#installation","title":"Overview - Installation","type":"extras"},{"doc":"Run mix licenses to get the list of packages and their licenses: $ mix licenses +---------------------+---------+--------------------------------------------------------+ | Package | Version | License | +---------------------+---------+--------------------------------------------------------+ | certifi | | BSD | | earmark | 1.3.2 | Apache 2.0 | | ex_doc | 0.20.2 | Apache 2.0 | | excoveralls | | Unsure (found: MIT, Unrecognized license file content) | | hackney | | Apache 2.0 | | idna | | Unsure (found: BSD, MIT) | | jason | | Apache 2.0 | | makeup | 0.8.0 | Unsure (found: BSD, Unrecognized license file content) | | makeup_elixir | 0.13.0 | BSD | | metrics | | BSD | | mimerl | | MIT | | nimble_parsec | 0.5.0 | Apache 2.0 | | ssl_verify_fun | | MIT | | table_rex | 2.0.0 | MIT | | unicode_util_compat | | Unsure (found: Apache 2.0, BSD) | +---------------------+---------+--------------------------------------------------------+ Run mix licenses --csv to output in csv format: Package,Version,License certifi,,BSD earmark,1.3.2,Apache 2.0 ex_doc,0.20.2,Apache 2.0 excoveralls,,&quot;Unsure (found: MIT, Unrecognized license file content)&quot; hackney,,Apache 2.0 idna,,&quot;Unsure (found: BSD, MIT)&quot; jason,,Apache 2.0 makeup,0.8.0,&quot;Unsure (found: BSD, Unrecognized license file content)&quot; makeup_elixir,0.13.0,BSD metrics,,BSD mimerl,,MIT nimble_parsec,0.5.0,Apache 2.0 ssl_verify_fun,,MIT unicode_util_compat,,&quot;Unsure (found: Apache 2.0, BSD)&quot; Flags --top-level-only - Only fetch license information from top level dependencies (e.g. packages that are directly listed in your application's mix.exs ). Excludes transitive dependencies.","ref":"readme.html#usage","title":"Overview - Usage","type":"extras"},{"doc":"You may call the function Licensir.Scanner.scan() from your Elixir application to get a list of license data per dependency. iex&gt; Licensir.Scanner . scan ( [ ] ) [ % Licensir.License { app : :jason , dep : % Mix.Dep { app : :jason , deps : ... } , file : &quot;Apache 2&quot; , hex_metadata : [ &quot;Apache 2.0&quot; ] , license : &quot;Apache 2.0&quot; , mix : nil , name : &quot;jason&quot; , version : nil } , % Licensir.License { ... } , ... ]","ref":"readme.html#usage-as-a-library","title":"Overview - Usage as a library","type":"extras"},{"doc":"Copyright (c) 2017, Unnawut Leepaisalsuwanna. This library is released under the MIT License. See the LICENSE.md file for further details. This project contains 3rd party work as follow: ASCII table rendering: a partial copy of djm/table_rex . CSV rendering: a partial copy of beatrichartz/csv .","ref":"readme.html#copyright-and-license","title":"Overview - Copyright and License","type":"extras"}]